; Testprogramm fr LED-Display-Treiber
; Zhlt im Sekundentakt von 00 bis 99 und gibt
; Zahl auf zwei 7-Segment-Displays aus.
; Nur 3 Pins vom AVR werden bentigt!

; 4 Mhz interner Oszillator
;-------------------------------------------------------------------------------
;	Einbinden der controllerspezifischen Definitionsdatei
;-------------------------------------------------------------------------------
.NOLIST								; List-Output ausschalten
.INCLUDE "m8def.inc"				; AVR-Definitionsdatei einbinden
.LIST								; List-Output wieder einschalten


.ORG	0x0000						; Programm beginnt an der FLASH-Adresse 0x0000

.DEF	Temp1  = r16				; allgemeine temp Register, zur kurzfristigen Verwendung
.Def	Temp2  = r17

.EQU	LedPort=PORTC				; M5481 an Port C
.EQU	pLedDdr=DDRC			
.EQU	Led_EN = 1					; Pin /Enable (13) vom M5481 am PortC.1
.EQU	Led_Clock = 2				; Pin Clock (11) vom M5481 am PortC.2
.EQU	Led_Data = 3				; Pin Data In (12) vom M5481 am PortC.3


;Stapel initialisieren (fuer Unterprogramme bzw. Interrupts)
		ldi   Temp1,HIGH(RAMEND)	;RAMEND (SRAM) ist in der Definitions-
		out	  SPH,Temp1				;datei festgelegt	
	    ldi	  Temp1,LOW(RAMEND)
		out	  SPL,Temp1

		ldi   temp1,0b00001110		; PortC-Pins auf Ausgang schalten
		out   pLedDdr,temp1
		sbi   LedPort,Led_EN		; /Enable auf High


; Sekundenzhler und Anzeige auf LED-Anzeigen
M1:		ldi   temp1,0				; Zhler beginnt bei 0
Main:	ldi   XL,0xFF				; 1 Sekunden Schleife bei 4 Mhz
		ldi   XH,0xFF
LO:		ldi   temp2,20
LO2:	dec   temp2
		brne  LO2
		sbiw  X,1		
		brne  LO  
        
		rcall LED_OUT				; Zahl ausgeben
		
		inc   temp1					; Zahl erhhen
		cpi   temp1,100				; schon 100?
		brne  LOUT					; nein
		rjmp  M1					; ja

LOUT:	rjmp  Main

;****** M5481-Routine einbinden ******
.INCLUDE "M5481Drv.asm"	
